#include "utilities.h"

// cast d'un QPoint en Point3D
Point3D  *
qPointToPoint3D(const QPoint& point)
{
return new Point3D(point.x(), point.y(), 0);
}


// cast d'un Point3D * en QPoint
QPoint
point3DToQPoint(Point3D * point)
{
  return QPoint((int)(point->getCoordinate(0)),
		(int)(point->getCoordinate(1)));
}

// calcul de la distance entre 2 QPoint
double
calculateDistance(const QPoint& center, const QPoint& pTemp)
{
  return sqrt((double)( (center.x() - pTemp.x()) * (center.x() - pTemp.x()) 
	       + (center.y() - pTemp.y()) * (center.y() - pTemp.y()) ) );
}

// galit entre 2 QPoints
bool
equalQPoint(QPoint pA, QPoint pB)
{
  return ( (pA.x() == pB.x()) && (pA.y() == pB.y()) );
}

// savoir si 2 QPoints sont "proches"
bool
isNear(QPoint p, QPoint pref)
{
  int ecart = 10;
  return ( ( p.x() >= (pref.x() - ecart) )
	   && ( p.x() <= (pref.x() + ecart) )
	   && ( p.y() >= (pref.y() - ecart) )
	   && ( p.y() <= (pref.y() + ecart) )
	   );
}

// savoir si on est prs d'un point dj dfini
// on retourne l'indice du point de rfrence dans le vecteur
int
nearPoint(QPoint point, vector<QPoint> vect)
{
  int res = -1;
  unsigned int i = 0;
  bool trouve = false;
  while ( (i < vect.size()) && !trouve)
    {
      if (isNear(point,vect[i]))
	{
	  res = i;
	  trouve = true;
	}
      i++;
    }
  return res;      
}


// changement de repre : changement aller
Point3D changeCoordinateSystem(const Point3D& point, const Point3D& origin)
{
  return Point3D(point[0]-origin[0],point[1]-origin[1],point[2]-origin[2]);
};

// changement de repre : changement retour
Point3D changeCoordinateSystemReverse (const Point3D &point, const Point3D &origin)
{
  return  Point3D(point[0]+origin[0],point[1]+origin[1],point[2]+origin[2]);
};

// effacer un vector de points 3D
void clearVector(vector<Point3D *> vect)
{
  for (unsigned int i = 0; i < vect.size(); i++)
    delete vect[i];

  vect.clear();
}
