/** @file utilities.h */

//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                       /
// Projet : Gnrateur de cylindres gnraliss                                          /
//                                                                                       /
// Nom du fichier : utilities.h                                                          /
//                                                                                       /
// Creation : 20/11/2005                                                                 /
//                                                                                       /
// Description : contient les fonctions partages par plusieurs classes.                 /                                                                                      /
//                                                                                       /            
// Auteurs : - Guitteny Fabrice                                                          /
//           - Idiart Baptiste                                                           /
//           - Le Goff Erwan                                                             /
//                                                                                       /
//////////////////////////////////////////////////////////////////////////////////////////

#ifndef UTILITIES_H
#define UTILITIES_H

#include <stdlib.h>
#include <vector>
#include "math.h"

#include <qpainter.h>

#include "../primitives/point.h"

// cast d'un QPoint en Point3D
Point3D  * qPointToPoint3D(const QPoint& point);

// cast d'un Point3D * en QPoint
QPoint point3DToQPoint(Point3D * point);

// calcul de la distance entre 2 QPoint
double calculateDistance(const QPoint& center, const QPoint& pTemp);

// galit entre 2 QPoints
bool equalQPoint(QPoint pA, QPoint pB);

// savoir si 2 QPoints sont "proches"
bool isNear (QPoint p, QPoint pref);

// savoir si on est prs d'un point dj dfini
// on retourne l'indice du point de rfrence dans le vecteur
int nearPoint(QPoint point, vector<QPoint> vect);

// changement de repre : changement aller
Point3D changeCoordinateSystem(const Point3D& point, const Point3D& origin);

// changement de repre : changement retour
Point3D changeCoordinateSystemReverse(const Point3D& point, const Point3D& origin);

// effacer un vector de points 3D
void clearVector(vector<Point3D *> vect);

#endif

