/** @file segment.h */

//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                       /
// Projet : Gnrateur de cylindres gnraliss                                          /
//                                                                                       /
// Nom du fichier : segment.h                                                            /
//                                                                                       /
// Creation : 20/11/2005                                                                 /
//                                                                                       /
// Description : La classe Segment permet de spcifier et de dessiner des segments.      / 
//                                                                                       /
// Auteurs : - Guitteny Fabrice                                                          /
//           - Idiart Baptiste                                                           /
//           - Le Goff Erwan                                                             /
//                                                                                       /
//////////////////////////////////////////////////////////////////////////////////////////

#ifndef SEGMENT_H
#define SEGMENT_H

#include<iostream>
#include <qpainter.h>
#include "primitive.h"
using namespace std;

/** La classe Segment permet de spcifier et de dessiner des segments. 
 *
 * @author Guitteny Fabrice
 * @author Idiart Baptiste
 * @author Le Goff Erwan
 */

///////////////////////////////////////////////////////////////////////////////////////////
//  Classe Segment                                                                       //
///////////////////////////////////////////////////////////////////////////////////////////

class Segment : public Primitive 
{
  public :
  
    /** constructeur par dfaut */
    Segment();

  /** constructeur : points extrmits du segment
   * @param pA 1re extrmit
   * @param pB 2me extrmit
   */	
  Segment(Point3D * pA, Point3D * pB);
  
  /** constructeur par copie
   * @param seg segment
   */
  Segment(const Segment& seg);
  
  // destructeur
  ~Segment() {};

  /** mthode d'affichage d'un segment (Bresenham)
   * @param paint affichage dans un QPainter
   */
  virtual void display(QPainter& paint);

  /** ecrit la primitive dans un fichier xml
   * @param elem balise courante dans le fichier XML
   */
  virtual void toXML(QDomElement &elem);

  /** changement des points dfinissant un segment
   * @param refPoint point  modifier
   * @param modifPoint nouvelle valeur du point
   */
  virtual void setPrimitive(QPoint & refPoint, QPoint & modifPoint);
  
  /** accesseur : 1re extrmit
   * @return 1re extrmit
   */
  Point3D * getPointA();

  /** accesseur : 2me extrmit
   * @return 2me extrmit
   */
  Point3D * getPointB();

  /** modificateur : 1re extrmit
   * @param pA 1re extrmit
   */
  void setPointA(Point3D * pA);

  /** modificateur : 2me extrmit
   * @param pB 2me extrmit
   */
  void setPointB(Point3D * pB);

};

#endif
