#include "pgnparser.h"


PgnParser::PgnParser()
{
 //initialisation du parser
  nbPoints=0;
  nbPolys = 0;
}


void PgnParser::exportPGN(const char* filename)
{
  ofstream wrlfile(filename);
  
  wrlfile << "#PGN format" << endl;
  wrlfile << "#Generated by PgnParser" <<endl <<endl;

  wrlfile << nbPoints <<"\t"<< nbPolys <<endl;
  for (int i=0;i<nbPoints; i++) {
    wrlfile << (pointsList[i])->getCoordinate(0) << " "
	    << (pointsList[i]) ->getCoordinate(1)<< " "
	    << (pointsList[i]) ->getCoordinate(2)<< endl;
  } 
  wrlfile << endl;
  for (int i=0;i<nbPolys*3; i+=3) {      
    wrlfile << referencesList[i] <<" "
	    << referencesList[i+1]<<" "
	    << referencesList[i+2] 
	    << endl;
    } 
    wrlfile << endl;

    wrlfile.close();
}




//parser de fichier PGN brut
void PgnParser::importPGN(const char* filename)
{
  ifstream file(filename);
  bool lpoints = false;//flag indiquant si l'on est en train de parser la liste de points
  bool lfacets =false;//idem pour la liste de face
  
  string line;
  
  Point3D *p;
  float px=0.0 , py=0.0 , pz=0.0;
  
  int refp1,refp2,refp3;
  int cptPoints=0;

  unsigned int i=0,j=0;//indices de position dans la ligne
  
  
  while(getline(file, line))
    {

      delSpace(line);   
      
      if((line[0]!='#')&&(line!="")){
	
	if((!lpoints)&&(!lfacets))
	  {
	    //rcupration du nombre de points
	    while((line[i]!='\t')&&(i<line.size()))i++;
	    nbPoints=stoi(line.substr(0,i));

	    //et du nombre de faces
	    nbPolys=stoi(line.substr(i,line.size()-i));
	    lpoints = true;
	   
	  }
	else if((lpoints)&&(cptPoints<nbPoints))
	  {
	    cptPoints++;
	    //on parse la liste de points
	    i=0;
	    while((line[i]!=' ')&&(i<line.size()))i++;
	    px=stof(line.substr(0,i));
	    
	    j=i+1;
	    while((line[j]!=' ')&&(j<line.size()))j++;	  
	    py=stof(line.substr(i+1,j-i-1));
	    	  
	    pz=stof(line.substr(j+1,line.size()-j-1));
	    
	    p = new Point3D(px,py,pz);
	    pointsList.push_back(p);
	  }
	else {//on parse la liste de faces
	  i=0;
	  j=0;
	   while((line[i]!=' ')&&(i<line.size()))i++;
	   refp1=stoi(line.substr(0,i));
	   referencesList.push_back(refp1);
	   j=i+1;
	   while((line[j]!=' ')&&(j<line.size()))j++;
	   refp2=stoi(line.substr(i+1,j-i-1));
	   referencesList.push_back(refp2);
	   refp3=stoi(line.substr(j+1,line.size()-j-1));
	   referencesList.push_back(refp3);
	 }
	
      }
    }
  
  file.close();
  
}


