/** @file pgnparser.h */

//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                       /
// Projet : Gnrateur de cylindres gnraliss                                          /
//                                                                                       /
// Nom du fichier : pgnparser.h                                                          /
//                                                                                       /
// Creation : 20/11/2005                                                                 /
//                                                                                       /
// Description : La classe pgnparser regoupe toutes les fonctionalits ncssaires       /
//               au parsing d'un fichier de type polygone PGN                            /
//               La syntaxe de ce type de fichier est la suivante :                      /
//                         nombre_de_points nombre_de_polygones                          /
//                                                                                       /
//                         Liste de points (x1 y1 z1, x2 y2 z2, ...)                     /
//                         Liste de polygones (rp1 rp2 rp3, ...)                         /
//                                                                                       /
//                                                                                       /
// Auteurs : - Guitteny Fabrice                                                          /
//           - Idiart Baptiste                                                           /
//           - Le Goff Erwan                                                             /
//                                                                                       /
//////////////////////////////////////////////////////////////////////////////////////////

#ifndef PGNPARSER_H
#define PGNPARSER_H

#include <iostream>
#include <string.h>
#include <stdio.h>
#include <fstream>
#include <math.h>
#include <vector>

#include "../primitives/point.h"
#include "utils.h"
#include "parser.h"

using namespace std;

/**
 * La classe pgnparser regoupe toutes les fonctionalits ncssaires       
 * au parsing d'un fichier de type polygone PGN.
 * La syntaxe de ce type de fichier est la suivante :
 *        nombre_de_points nombre_de_polygones
 *        Liste de points (x1 y1 z1, x2 y2 z2, ...)
 *        Liste de polygones (rp1 rp2 rp3, ...)
 *
 *  @author Guitteny Fabrice
 *  @author Idiart Baptiste
 *  @author Le Goff Erwan
 */
///////////////////////////////////////////////////////////////////////////////////////////
//  Classe PgnParser                                                                     //
///////////////////////////////////////////////////////////////////////////////////////////
class PgnParser: public Parser
{
  
  public :
   /**Constructeur de PgnParser
   */
    PgnParser();
    /**Import d'un fichier PGN
     * @param filename nom du fichier
     */
    void importPGN(const char* filename);
    /**Export d'un fichier en PGN
     * @param filename nom du fichier
     */
    void exportPGN(const char* filename);
    
}
;


#endif



