#include "vrmlparser.h"


//parser de fichier vrml de base
void VrmlParser::importVrml(const char* filename)
{
  ifstream file(filename);
  
  string line;
  string pX,pY,pZ;
  
  Point3D *p;
  float px=0.0 , py=0.0 , pz=0.0;
  int goodPosition = 0;
  int describePoly = 0;
  int endIndexedFace = 0;
  
  int refp1,refp2,refp3;
  
  
  while((getline(file, line)&&(endIndexedFace==0))) {    
    delSpace(line);   
    //on se place juste sur la liste de points:
    
    if(goodPosition==0){ 
      while(line.find("point",0)==string::npos)
      	  getline(file,line);delSpace(line);	
      goodPosition=1;
    }
    else
      {
	if(line.find("coordIndex",0)!=string::npos)
	  {
	    describePoly=1;
	    getline(file,line);
	    delSpace(line);
	  }
	
	if(describePoly==0)
	  {
	    if(line[0]!='}')
	      {
		unsigned int i=0;
		
		//sauvegarde de la coordonne x
		while((line[i]!=' ')&&(i<line.size()))i++;
		
		px=stof(line.substr(0,i));
		
		unsigned int j=i+1;	  
		//sauvegarde de l'ordonne y
		while((line[j]!=' ')&&(j<line.size()))j++;	  
		py=stof(line.substr(i+1,j-i-1));	  	  
		//sauvegarde de la cote z  
		unsigned int k=j+1;
		while((line[k]!=',')&&(line[k]!=']')&&(k<line.size()))k++; 	  
		pz=stof(line.substr(j+1,k-j-1));
	  
		//construction du point p   
		p = new Point3D(px,py,pz);
	    
		//ajout au tableau de point
		
		pointsList.push_back(p);
		
	      }
	    
	  }
	else
	  {
	    if(line[0]!='}')
	      {
	   
		unsigned int i=0;
		//sauvegarde de la ref du point1
		while((line[i]!=',')&&(i<line.size()))i++;
		
		refp1=stoi(line.substr(0,i));
		referencesList.push_back(refp1);
		
		unsigned int j=i+1;
		
		//sauvegarde de la ref du point2
		while((line[j]!=',')&&(j<line.size()))j++;
		
		refp2=stoi(line.substr(i+2,j-i-1));
		
		referencesList.push_back(refp2);
		
		//sauvegarde de la cote z  
		unsigned int k=j+1;
		while((line[k]!=',')&&(line[k]!=']')&&(k<line.size()))k++;
	   
	   
		refp3=stoi(line.substr(j+2,k-j-2));
		referencesList.push_back(refp3);	
		if(line.find("]",0)!=string::npos) 
		  endIndexedFace=1;
	      }
	  }
      }
    
    
  }  
  
  nbPoints = pointsList.size();
  nbPolys = referencesList.size()/3;
  file.close();
  
}


void VrmlParser::exportVrml(const char* filename)
{
    ofstream wrlfile(filename);
    
    wrlfile << "#VRML V2.0 utf8" << endl
	    << endl;
    wrlfile << "# Generated by VrmlParser" <<endl;
    
    wrlfile << "Shape" <<endl << "{" <<endl;
    wrlfile << "geometry IndexedFaceSet" <<endl << "{" <<endl;
    wrlfile << "coord Coordinate" <<endl << "{" <<endl;
    wrlfile << "point [" <<endl;
    
    for (int i=0;i<nbPoints-1; i++) {
      
      wrlfile << "\t" << (pointsList[i])->getCoordinate(0) << " "
	      << (pointsList[i]) ->getCoordinate(1)<< " "
	      << (pointsList[i]) ->getCoordinate(2)<< "," << endl;
      
    }
    //le dernier points est trait  part car pas de ','
    
    wrlfile << "\t" << (pointsList[nbPoints-1])->getCoordinate(0) << " "
	    << (pointsList[nbPoints-1])->getCoordinate(1) << " "
	    << (pointsList[nbPoints-1])->getCoordinate(2) << "]" << endl;
    
    wrlfile << "}"<<endl;
    wrlfile << "coordIndex [" << endl;
    
    for (int i=0;i<(3 * nbPolys )-3; i+=3) {
      
      wrlfile << "\t" << referencesList[i] << ", "
	      << referencesList[i+1] << ", "
	      << referencesList[i+2] << ", " 
	      << "-1," <<endl;
      
    }
    wrlfile << "\t" << referencesList[(3*nbPolys)-3] << ", "
	    << referencesList[(3*nbPolys)-2] << ", "
	    << referencesList[(3*nbPolys)-1] << ", "
	    << "-1]" <<endl;
    
    wrlfile << "}"<<endl;
    wrlfile << "}"<<endl;
    
    wrlfile.close();
    
    
}
