/** @file vrmlparser.h */

//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                       /
// Projet : Gnrateur de cylindres gnraliss                                          /
//                                                                                       /
// Nom du fichier : vrmlparser.h                                                         /
//                                                                                       /
// Creation : 20/11/2005                                                                 /
//                                                                                       /
// Description : La classe vrmlparser regoupe toutes les fonctionalits ncssaires      /
//               au parsing d'un fichier vrml 97 ainsi qu'a son dition                  /
//               Les fichiers vrml doivent obligatoirement vrifier cette syntaxe.       /
//                                                                                       /
//                                                                                       /            
// Auteurs : - Guitteny Fabrice                                                          /
//           - Idiart Baptiste                                                           /
//           - Le Goff Erwan                                                             /
//                                                                                       /
//////////////////////////////////////////////////////////////////////////////////////////

#ifndef VRMLPARSER_H
#define VRMLPARSER_H

#include <iostream>
#include <string.h>
#include <stdio.h>
#include <fstream>
#include <math.h>
#include <vector>

#include "../primitives/point.h"
#include "utils.h"
#include "parser.h"



using namespace std;

/**
 *
 * La classe vrmlparser regoupe toutes les fonctionalits ncssaires
 * au parsing d'un fichier vrml 97 ainsi qu'a son dition            
 * Les fichiers vrml doivent obligatoirement vrifier cette syntaxe. 
 *
 *  @author Guitteny Fabrice
 *  @author Idiart Baptiste
 *  @author Le Goff Erwan
 */
///////////////////////////////////////////////////////////////////////////////////////////
//  Classe VrmlParser                                                                    //
///////////////////////////////////////////////////////////////////////////////////////////

class VrmlParser: public Parser
{

public :
  /**Constructeur de VrmlParser
   */
  VrmlParser(){};
  /**Import d'un fichier Vrml 97
   * @param filename nom du fichier
   */
  void importVrml(const char* filename);
  /**Export d'un fichier en Vrml 97
   * @param filename nom du fichier
   */
  void exportVrml(const char* filename);
  
}
;


#endif



